<!doctype html>

<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">

  <title>Semgrep Merge Tool</title>
  <meta name="description" content="The default usage guide for the Semgrep Merge Tool.">

  <meta property="og:title" content="Semgrep Merge Tool">
  <meta property="og:type" content="website">
  <meta property="og:description" content="The default usage guide for the Semgrep Merge Tool.">
</head>

<body>

<h1>Semgrep Merge Tool</h1>

<p>See the project <a href="https://gitlab.wikimedia.org/repos/security/semgrep-merge-tool/-/blob/main/README.md">README</a> for more details.</p>

<h2>Basic Usage</h2>

<p>The Semgrep Merge Tool is designed to be a proxy layer (of sorts) for accessing
curated repositories of semgrep rules.  All repositories available here <em>MUST</em> feature
<a href="https://opensource.org/licenses">OSI-compliant</a> or <a
href="https://freedomdefined.org/Definition">free-culture-compliant</a> licenses.</p>

<h3>Available Repositories and Rule Directories</h3>
<ol>
{% for key, repo in repos %}
<li>
<span><b><a href="index.php?q={{ key }}">{{ key }}</a></b>{% if repo.cached != '' %}&nbsp;(cached: <a href="index.php?q={{ repo.cached }}">{{ repo.cached }}</a>){% endif %}</span>
 <ol>
{% for dir, cached in repo.subdirs %}
	{% if dir != '.' %}
		<li><a href="index.php?q={{ key }}/{{ dir }}">{{ dir }}</a>{% if cached != '' %}&nbsp;(cached: <a href="index.php?q={{ cached }}">{{ cached }}</a>){% endif %}</li>
	{% endif %}
{% endfor %}
</ol>
</li>
{% endfor %}
</ol>
<h3>Available Policies</h3>
<ol>
	{% for pol, subdirs in policies %}
	 <li><span><b><a href="index.php?q={{ pol }}">{{ pol }}</a></b></span>{% if subdirs.cached != '' %}&nbsp;(cached: <a href="index.php?q={{ subdirs.cached }}">{{ subdirs.cached }}</a>){% endif %}</li>
		<ul>
		{% for dir, cached in subdirs.subdirs %}
		<li><span>{{ dir }}</span></li>
		{% endfor %}
		</ul>
	{% endfor %}
</ol>

<h3>Usage via the <a href="https://semgrep.dev/docs/cli-reference/">Semgrep CLI</a></h3>

<ol>
<li><p>Requesting a set of curated rules via a policy:</p>
<pre>
# use the 'php' policy
$ semgrep --metrics=off --config={{ base_url }}?q=php
</pre></li>
<li><p>Requesting a single repository of rules:</p>
<pre>
# use all of the rule files within repos/security/wikimedia-semgrep-rules
$ semgrep --metrics=off --config={{ base_url }}?q=repos/security/wikimedia-semgrep-rules
</pre></li>
<li><p>Requesting a specific directory of rules within a repository:</p>
<pre>
# use the http leaks rules within repos/security/wikimedia-semgrep-rules
$ semgrep --metrics=off --config={{ base_url }}?q=repos/security/wikimedia-semgrep-rules/http_leaks
</pre></li>
<li><p>Requesting a specific rule within a repository:</p>
<pre>
# use the http leaks rule for JUST PHP CODE within repos/security/wikimedia-semgrep-rules
$ semgrep --metrics=off --config={{ base_url }}?q=repos/security/wikimedia-semgrep-rules/http_leaks/http-leak-source-code-php.yml
</pre></li>
<li><p>Requesting multiple repositories or rules:</p>
<pre>
# request all of the rules from both repos/security/wikimedia-semgrep-rules and ajinabraham/njsscan
$ semgrep --metrics=off --config={{ base_url }}?q=repos/security/wikimedia-semgrep-rules,ajinabraham/njsscan
</pre></li>
<li><p>Requesting cache hashes:</p>
<pre>
# hash value for repos/security/wikimedia-semgrep-rules, in cache
$ semgrep --metrics=off --config={{ base_url }}?q=345c092990da1125
</pre></li>
</ol>

</body>
</html>
